/*
BUTTON   Coding(HEX)
CH-   =A25D
CH    =629D
CH+   =E21D
LEFT  =22DD
RIGHT =02FD
STOP  =C23D
-     =E01F
+     =A857
EQ    =906F
0     =6897
100+  =9867
200+  =B04F
1     =30CF
2     =18E7
3     =7A85
4     =10EF
5     =38C7
6     =5AA5
7     =42BD
8     =4AB5
9     =52AD
*/
#include <IRremote.h>
const uint16_t BUTTON_0 = 0x6897;
const uint16_t BUTTON_1 = 0x30CF;
const uint16_t BUTTON_2 = 0x18E7;
const uint16_t BUTTON_3 = 0x7A85;
const uint16_t BUTTON_4 = 0x10EF;
const uint16_t BUTTON_5 = 0x38C7;
const uint16_t BUTTON_6 = 0x5AA5;
const uint16_t BUTTON_7 = 0x42BD;
const uint16_t BUTTON_8 = 0x4AB5;
const uint16_t BUTTON_9 = 0x52AD;

int LED_R=3;
int LED_G=4;
int RECV_PIN = 5;

IRrecv irrecv(RECV_PIN);

decode_results results;
uint16_t lastCode = 0;
void setup()
{
  Serial.begin(9600);
  irrecv.enableIRIn(); // Start the receiver
  pinMode(LED_R, OUTPUT);  
  pinMode(LED_G, OUTPUT);    
}

void loop() {
  if (irrecv.decode(&results)) {
    uint16_t resultCode = (results.value & 0xFFFF);
   /* The remote will continue to spit out 0xFFFFFFFF if a 
     button is held down. If we get 0xFFFFFFF, let's just
     assume the previously pressed button is being held down */
    if (resultCode == 0xFFFF)
      resultCode = lastCode;
    else
      lastCode = resultCode;

    // This switch statement checks the received IR code against
    // all of the known codes. Each button press produces a 
    // serial output, and has an effect on the LED output.
    switch (resultCode)
    {
      case BUTTON_0:
        Serial.println("0");
        break;
      case BUTTON_1:
        Serial.println("1");
        digitalWrite(LED_R, HIGH);
        break;
      case BUTTON_2:
        Serial.println("2");
        digitalWrite(LED_G, HIGH);
        break;
      case BUTTON_3:
        Serial.println("3");
        digitalWrite(LED_R, LOW);
        digitalWrite(LED_G, LOW);
        break;
      case BUTTON_4:
        Serial.println("4");
        break;
      case BUTTON_5:
        Serial.println("5");
        break;
      case BUTTON_6:
        Serial.println("6");
        break;
      case BUTTON_7:
        Serial.println("7");
        break;
        case BUTTON_8:
        Serial.println("8");
        break;
        case BUTTON_9:
        Serial.println("9");
        break;
      default:
        Serial.print("Unrecognized code received: 0x");
        Serial.println(results.value, HEX);
        break;        
    }    
    irrecv.resume(); // Receive the next value
  }
}
